#include "nvodm_imager.h"
#include "nvodm_imager_int.h"
#include <windows.h>
#include "I2CLib.h"

#define ZONE_ERR				DEBUGZONE(0)
#define ZONE_WARN				DEBUGZONE(1)
#define ZONE_FUNC				DEBUGZONE(2)
#define ZONE_INIT				DEBUGZONE(3)
#define ZONE_INFO    			DEBUGZONE(4)
#define ZONE_VERBOSE            DEBUGZONE(5)


char* GetParamName(NvOdmImagerParameter Param);


extern BYTE g_SensorI2C_Addr;
extern DWORD g_SensorI2C_OffsetWidth; // 1 or 2 bytes
extern DWORD g_SensorI2C_DataWidth; // 1 or 2 bytes
extern DWORD g_SensorI2C_Speed;
extern DWORD g_SensorI2C_pReadFn;
extern DWORD g_SensorI2C_pWriteFn;

NvBool SensorI2C_Open();
void SensorI2C_Close();
NvBool SensorI2C_Write(WORD offset, WORD data);
NvBool SensorI2C_Read(WORD offset, WORD* pData);

#define SEQUENCE_WAIT_MS                (0xFFFE)
#define SEQUENCE_END                    (0xFFFF)
#define SEQUENCE_FAST_SETMODE_START     (0xFFFD)
#define SEQUENCE_FAST_SETMODE_END       (0xFFFC)
#define SEQUENCE_CHANGE_ADDR            (0xFFFB)
NvBool SensorI2C_WriteSequence(DevCtrlReg16* SetModeSequence);
DWORD GetSensorMode();